解题报告Best Time to Buy and Sell Stock with Cooldown

题目

Say you have an array for which the ith element is the price of a given stock on day i.

Design an algorithm to find the maximum profit. You may complete as many transactions as you like (ie, buy one and sell one share of the stock multiple times) with the following restrictions:

You may not engage in multiple transactions at the same time (ie, you must sell the stock before you buy again).
After you sell your stock, you cannot buy stock on next day. (ie, cooldown 1 day)
Example:

Input: [1,2,3,0,2]
Output: 3
Explanation: transactions = [buy, sell, cooldown, buy, sell]

解题思路:

第一种方案, 假设数组长度为n, dp[i][j]为从i到j所能达到的最大收益,那么本题即求dp[0][n - 1],

对于dp[i][j], 其可能的cooldown位置有 I, i + 1, ..., j - 1, j,

所以存在递推关系

dp[i][j] = max{ dp[i][k - 1] + dp[k + 1][j]} k = i, i + 1, ... , j - 1, j

当k == i 时, dp[i][k - 1] 不存在,即只有dp[k + 1][j], 同理

当k == j 时, dp[k + 1][j] 不存在,即只有dp[i][k - 1]

prices[j] - prices[I] 为dp[I][j]的初始值

所以最终dp[i][j] = max(prices[j] - prices[I], max{dp[i][k - 1] + dp[k + 1][j]})

而题目希望求解的是dp[0][n - 1]. 所以i 从n-1往0求解,j从0往n-1求解

时间复杂度O(n^3) 空间复杂度O(n^2)

代码如下

class Solution {
public:
    //suppose cooldown at k
    //dp[i][j] = max{dp[i][k - 1] + dp[k + 1][j]} k = i ... j
    int maxProfit(vector<int>& prices) {
        int n = prices.size();
        if (0 == n) return 0;
        vector<vector<int>> dp(n, vector<int>(n, 0));
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                dp[i][j] = prices[j] - prices[i];
            }
        }

        for (int i = n - 1; i >= 0; i--) {
            for (int j = 0; j < n; j++) {
                //cout<<"i="<<i<<" j="<<j<<" "<<dp[i][j]<<endl;
                for (int k = i; k < j; k++) {
                    int tmp = 0;
                    if (k - 1 >= i) {
                        tmp += dp[i][k - 1];
                    }

                    if (k + 1 <= j) {
                        tmp += dp[k + 1][j];
                    }

                    dp[i][j] = max(dp[i][j], tmp);
                }
            }
        }

        return dp[0][n - 1];
    }
};

第二种方案:顺序DP

常规的DP的类型主要有三类,矩阵dp,一个一维数组的dp,两个一维数组的dp

矩阵dp 构造f[i][j], 一维dp构造f[i], 两个一维dp构造f[i][j]

本题恰好可以使用顺序dp,而且是一维的数组

解题思路:

每一天股票的持有状态可能有三种情况

cool down-->buy-->sell-->cool down-->buy-->sell-->cool down

状态转换的关系如上, leetcode讨论区有人画了状态图,非常容易理解, 参考链接

https://leetcode.com/explore/interview/card/top-interview-questions-hard/121/dynamic-programming/862/discuss/75928/Share-my-DP-solution-(By-State-Machine-Thinking)

也就是说

buy的状态 可能是从前一个buy 或者前一个cool down过来

sell的状态 只能是从前一个buy过来

cool down的状态 可能是从前一个cool down或者前一个sell的状态过来

这里需要搞清楚

1)sell 和 cool down的区别, sell状态只有 卖出的那个时刻状态是保持的, 卖完第二天状态就是cool down了.

2)buy 到 sell 之间的这段时间,按题意并不算cool down,而全是buy状态

3)sell 到 cool down之间的这段时间,全是cool down状态

由此可以得出

buy[i] = max(buy[i - 1], rest[i - 1] - prices[I]) // 这里用rest 表示 cool down

rest[i] = max(rest[i - 1], sell[I - 1])

sell[I] = buy[I - 1] + prices[i]

代码如下

java

class Solution {
    public int maxProfit(int[] prices) {
        int n = prices.length;
        if (0 == n) return 0;

        int[] buy = new int[n];
        int[] rest = new int[n];
        int[] sell = new int[n];

        buy[0] = -prices[0];
        rest[0] = 0;
        sell[0] = Integer.MIN_VALUE;

        for (int i = 1; i < n; i++) {
            buy[i] = Math.max(buy[i - 1], rest[i - 1] - prices[i]);
            rest[i] = Math.max(rest[i - 1], sell[i - 1]);
            sell[i] = buy[i - 1] + prices[i];
        }

        return Math.max(rest[n - 1], sell[n - 1]);
    }
}

c++

class Solution {
public:
    int maxProfit(vector<int>& prices) {
        int n = prices.size();
        if (0 == n) return 0;

        vector<int> buy(n, 0);
        vector<int> rest(n, 0);
        vector<int> sell(n, 0);
        buy[0] = -prices[0];
        rest[0] = 0;

        //不可能存在,所以收益取最小,因为i位置,我们希望取的是最大值,
        //将sell设置为最小值,表示永远不可能取该值
        sell[0] = INT_MIN;

        for (int i = 1; i < n; i++) {
            buy[i] = max(buy[i - 1], rest[i - 1] - prices[i]);
            rest[i] = max(rest[i - 1], sell[i - 1]);
            sell[i] = buy[i - 1] + prices[i];
        }

        return max(rest[n - 1], sell[n - 1]);
    }
};

原文地址:https://www.cnblogs.com/ctrlzhang/p/9536256.html

时间: 2024-11-03 03:25:39

解题报告Best Time to Buy and Sell Stock with Cooldown的相关文章

309. Best Time to Buy and Sell Stock with Cooldown

/* * 309. Best Time to Buy and Sell Stock with Cooldown * 2016-7-4 by Mingyang * http://buttercola.blogspot.com/2016/01/leetcode-best-time-to-buy-and-sell.html * *1. Define States * *To represent the decision at index i: *buy[i]: Max profit till inde

LeetCode Best Time to Buy and Sell Stock with Cooldown

原题链接在这里:https://leetcode.com/problems/best-time-to-buy-and-sell-stock-with-cooldown/ 题目: Say you have an array for which the ith element is the price of a given stock on day i. Design an algorithm to find the maximum profit. You may complete as many

Best Time to Buy and Sell Stock with Cooldown

题目: Say you have an array for which the ith element is the price of a given stock on day i. Design an algorithm to find the maximum profit. You may complete as many transactions as you like (ie, buy one and sell one share of the stock multiple times)

Best Time to Buy and Sell Stock with Cooldown -- LeetCode

Say you have an array for which the ith element is the price of a given stock on day i. Design an algorithm to find the maximum profit. You may complete as many transactions as you like (ie, buy one and sell one share of the stock multiple times) wit

Leetcode之动态规划(DP)专题-309. 最佳买卖股票时机含冷冻期(Best Time to Buy and Sell Stock with Cooldown)

股票问题: 309. 最佳买卖股票时机含冷冻期 714. 买卖股票的最佳时机含手续费 给定一个整数数组,其中第 i 个元素代表了第 i 天的股票价格 .? 设计一个算法计算出最大利润.在满足以下约束条件下,你可以尽可能地完成更多的交易(多次买卖一支股票): 你不能同时参与多笔交易(你必须在再次购买前出售掉之前的股票). 卖出股票后,你无法在第二天买入股票 (即冷冻期为 1 天). 示例: 输入: [1,2,3,0,2] 输出: 3 解释: 对应的交易状态为: [买入, 卖出, 冷冻期, 买入,

Best Time to Buy and Sell Stock系列

1.Best Time to Buy and Sell Stock II 1 class Solution { 2 public: 3 int maxProfit(vector<int>& prices) { 4 if(prices.size() < 1) //prices.size is unsigned int 5 return 0; 6 int pro = 0; 7 for(int i=0; i<prices.size()-1; i++) 8 { 9 if(price

[LeetCode] 123. Best Time to Buy and Sell Stock III 买卖股票的最佳时间 III

Say you have an array for which the ith element is the price of a given stock on day i. Design an algorithm to find the maximum profit. You may complete at most two transactions. Note:You may not engage in multiple transactions at the same time (ie,

LeetCode: Best Time to Buy and Sell Stock 解题报告

Best Time to Buy and Sell Stock Say you have an array for which the ith element is the price of a given stock on day i. If you were only permitted to complete at most one transaction (ie, buy one and sell one share of the stock), design an algorithm

LeetCode: Best Time to Buy and Sell Stock III 解题报告

Best Time to Buy and Sell Stock IIIQuestion SolutionSay you have an array for which the ith element is the price of a given stock on day i. Design an algorithm to find the maximum profit. You may complete at most two transactions. Note:You may not en